//I need to get better at AngularJS...

angular.module('beamng.apps')

.directive('trafficTool', ['bngApi', function (bngApi) {
	return {
		templateUrl: 'modules/apps/trafficTool/app.html',
		replace: false,
		restrict: 'E',
		scope: false,
		controller: function ($scope, $element, $attrs) {
			$scope.allStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "4px", appShow: "visible", divShow: "hidden"};
			$scope.inSymbol = "-";
			$scope.unit = "km/h";
			$scope.metric = true;
			$scope.visible = true;
			$scope.quantity = 1;
			$scope.speedLimit = 50;
			$scope.respawnRate = 1;
			$scope.numColor = "#000000";
			$scope.colorModeOptions = [
				{mode: 1, txt: "Unchanged"}, {mode: 2, txt: "Standard"}, {mode: 3, txt: "Random"}
			];
			$scope.botModeOptions = [
				{mode: 1, txt: "Normal"}, {mode: 2, txt: "Flee"}, {mode: 3, txt: "Chase"}, {mode: 4, txt: "Disabled"}
			];
			//Why can I only pass number values back into the game and not strings?
			$scope.smartAI = true;
			$scope.altRespawn = false;
			
			this.init = function() {
				var command = `extensions.freeroam_dynamicTraffic.ready()`;
				bngApi.engineLua(command);
			}
			
			this.toggleAll = function() {
				$scope.visible = !$scope.visible;
				if($scope.visible == false) {
					$scope.allStyle = {appWidth: "24px", appHeight: "24px", inLeft: "4px", inRight: "auto", appShow: "hidden", divShow: "hidden"};
					$scope.inSymbol = "+";
				} else {
					$scope.allStyle = {appWidth: "100%", appHeight: "100%", inLeft: "auto", inRight: "4px", appShow: "visible", divShow: "hidden"};
					$scope.inSymbol = "-";
				}
			}
			
			this.showList = function() {
				$scope.allStyle.divShow = "visible";
			}
			
			this.setGroup = function(n) {
				$scope.allStyle.divShow = "hidden";
				var command = `extensions.freeroam_dynamicTraffic.setGroup(` + n + `)`;
				bngApi.engineLua(command);
			}
			
			this.toggleUnits = function() {
				$scope.metric = !$scope.metric;
				var u = 1
				if($scope.metric == false) {
					$scope.unit = "mph";
					u = 2;
				} else {
					$scope.unit = "km/h";
					u = 1;
				}
				var command = `extensions.freeroam_dynamicTraffic.toggleUnits(` + u + `)`;
				bngApi.engineLua(command);
			}
			
			this.setQuantity = function() {
				if($scope.quantity >= 12) {
					$scope.numColor = "#FF0000";
				} else {
					$scope.numColor = "#000000";
				}
				var command = `extensions.freeroam_dynamicTraffic.setQuantity(${this.quantity})`;
				bngApi.engineLua(command);
			}
			
			this.spawnVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.spawnVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.clearVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.clearVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.activateVehicles = function() {
				var command = `extensions.freeroam_dynamicTraffic.activateVehicles()`;
				bngApi.engineLua(command);
			}
			
			this.setSpeedLimit = function() {
				var command = `extensions.freeroam_dynamicTraffic.setSpeedLimit(${this.speedLimit})`;
				bngApi.engineLua(command);
			}
			
			this.setRespawnRate = function() {
				var command = `extensions.freeroam_dynamicTraffic.setRespawnRate(${this.respawnRate})`;
				bngApi.engineLua(command);
			}
			
			this.changeColorMode = function() {
				var command = `extensions.freeroam_dynamicTraffic.changeColorMode(${this.colorModeOptions.mode})`;
				bngApi.engineLua(command);
			}
			
			this.changeBotMode = function() {
				var command = `extensions.freeroam_dynamicTraffic.changeBotMode(${this.botModeOptions.mode})`;
				bngApi.engineLua(command);
			}
			
			this.toggleSmartBots = function() {
				var command = `extensions.freeroam_dynamicTraffic.toggleSmartSpeed(${this.smartBots})`;
				bngApi.engineLua(command);
			}
			
			this.toggleAltRespawn = function() {
				var command = `extensions.freeroam_dynamicTraffic.toggleAltRespawn(${this.altRespawn})`;
				bngApi.engineLua(command);
			}
		},
		controllerAs: 'ctrl'
	};
}]);